#include<pthread.h>
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<sys/neutrino.h>

void  *server()
{
	int chid, rcvid;
	char receive_buf[25], reply_buf[25];
	printf("1) Server thread:  Channel creating ...");
	chid = ChannelCreate(0);
	if(chid<0)
	{
		perror("Server error");
		exit(EXIT_FAILURE);
	}	
	printf(" CHID = %d\n", chid);
	sleep(1);
	printf("4) Server thread: Listen to channel %d\n", chid);
	rcvid = MsgReceive(chid, &receive_buf, sizeof(receive_buf), NULL);
	printf("   Server thread: massage <%s> has recived.\n", &receive_buf);
	strcpy(reply_buf, "Our strong answer");
	printf("5) Server thread: answering with <%s> (Status=15052002).\n", &reply_buf);
	MsgReply(rcvid, 15052002, &reply_buf, sizeof(reply_buf));
	ChannelDestroy(chid);
	printf("   Server thread:  Good by.\n");
	pthread_exit(NULL);
}


void  *client()
{
	int coid, status;
	pid_t PID;
	char send_buf[25], reply_buf[25];
	
	PID=getpid();
	printf("2) Client thread: connecting to channel ... ");
	coid = ConnectAttach(0, PID, 1 , 0, 0);
	if(coid<0)
	{
		perror("Client error");
		exit(EXIT_FAILURE);
	}
	printf("COID = %d\n", coid);
	strcpy(send_buf, "It's very simple example");
	printf("3) Client thread: sending massage <%s>.\n", &send_buf);
	status = MsgSend(coid, &send_buf, sizeof(send_buf), &reply_buf, sizeof(reply_buf));
	printf("   Client thread: I have replied with massage <%s> (status=%d).\n", &reply_buf, status);
	ConnectDetach(coid);
	printf("   Client thread:  Good by.\n");
	pthread_exit(NULL);
}

int main()
{
	pthread_t	server_tid, client_tid;
	printf("Main thread: starting Server & Client ...\n");
	pthread_create(&server_tid, NULL, server, NULL);
	pthread_create(&client_tid,   NULL, client,   NULL);
	printf("Main thread: waiting for child threads exiting ...\n");
	pthread_join(client_tid, NULL);
	printf("Main thread: the end.\n");
	return EXIT_SUCCESS;
}
